Bug 728649 - Review Request: airrac - C++ Simulated Revenue Accounting (RAC) System Library
Review Request: airrac - C++ Simulated Revenue Accounting (RAC) System Library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Martin Gieseking
Fedora Extras Quality Assurance
:
Depends On: 702987
Blocks: 750099 760594
  Show dependency treegraph
 
Reported: 2011-08-05 20:45 EDT by Denis Arnaud
Modified: 2011-12-06 10:19 EST (History)
5 users (show)

See Also:
Fixed In Version: airrac-0.1.0-2.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-30 16:38:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
martin.gieseking: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Denis Arnaud 2011-08-05 20:45:44 EDT
Spec URL: http://denisarnaud.fedorapeople.org/sim/airrac/airrac-0.1.0-1.spec
SRPM URL: https://downloads.sourceforge.net/project/airrac/fedora_15/airrac-0.1.0-1.fc15.src.rpm
Description:
AirRAC is a C++ library of airline revenue accounting classes and
functions, mainly targeting simulation purposes.
Comment 1 Martin Krizek 2011-08-18 09:24:08 EDT
Hi Denis,
*informal* review follows:

[ OK ] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
$ rpmlint rpmbuild/SPECS/airrac.spec Downloads/airrac-0.1.0-1.fc15.src.rpm 
1 packages and 1 specfiles checked; 0 errors, 0 warnings.
[ OK ] MUST: The package must be named according to the Package Naming Guidelines.
[ BAD ] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. ===> Needs to be renamed to airrac.spec
[ OK ] MUST: The package must meet the Packaging Guidelines.
[ OK ] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[ OK ] MUST: The License field in the package spec file must match the actual license.
[ OK ] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[ OK ] MUST: The spec file must be written in American English.
[ OK ] MUST: The spec file for the package MUST be legible.
[ OK ] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
[ BAD ] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[ BAD ] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
===> I could not build rpm from provided srpm using 'mock -r fedora-15-x86_64 --rebuild airrac-0.1.0-1.fc15.src.rpm' -- seems like problem with tex, sorry if it was my bad due to unapproriate usage of mock.
[ OK ] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[ NA ] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[ OK ] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[ OK ] MUST: Packages must NOT bundle copies of system libraries.
[ OK ] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[ OK ] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[ OK ] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[ OK ] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[ OK ] MUST: Each package must consistently use macros.
[ OK ] MUST: The package must contain code, or permissable content.
[ OK ] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[ OK ] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[ OK ] MUST: Header files must be in a -devel package.
[ OK ] MUST: Static libraries must be in a -static package.
[ OK ] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[ OK ] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[ BAD ] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built. ===> I am not sure about that, are there any .la archives created? If not, consider it as OK.
[ OK ] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[ OK ] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[ OK ] MUST: All filenames in rpm packages must be valid UTF-8.

[ BAD ] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it. ===> No license file included.
[ OK ] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available.
[ BAD ] SHOULD: The reviewer should test that the package builds in mock. ===> As stated above.
[ BAD ] SHOULD: The package should compile and build into binary rpms on all
supported architectures. ===> As stated above.
[ OK ] SHOULD: The reviewer should test that the package functions as
described. A package should not segfault instead of running, for example.
[ OK ] SHOULD: If scriptlets are used, those scriptlets must be sane. This is
vague, and left up to the reviewers judgement to determine sanity.
[ BAD ] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency. ===> doc package doesn't require the base package.
[ OK ] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase,
and this is usually for development purposes, so should be placed in a -devel
pkg. A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb.
[ OK ] SHOULD: If the package has file dependencies outside of /etc, /bin,
/sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the
file instead of the file itself.
[ OK ] SHOULD: your package should contain man pages for binaries/scripts. If
it doesn't, work with upstream to add them where they make sense.
Comment 2 Martin Gieseking 2011-08-18 13:16:46 EDT
I'm going to sponsor Martin, so taking over the review. Since I'm busy at the moment, I'll continue later tonight or tomorrow morning.
Comment 3 Martin Gieseking 2011-08-19 04:27:10 EDT
(In reply to comment #1)
> [ BAD ] MUST: The spec file name must match the base package %{name}, in the
> format %{name}.spec unless your package has an exemption. ===> Needs to be
> renamed to airrac.spec

Right. However, the spec in the srpm is named correctly. It's just the name of the separately linked spec that doesn't satisfy the guidelines.


> [ OK ] MUST: The sources used to build the package must match the upstream
> source, as provided in the spec URL. Reviewers should use md5sum for this task.

Please always add the checksums (md5sum, sha1sum,...) of both tarballs to your reviews so that we can easily verify their identity.


> ===> I could not build rpm from provided srpm using 'mock -r fedora-15-x86_64
> --rebuild airrac-0.1.0-1.fc15.src.rpm' -- seems like problem with tex, sorry if
> it was my bad due to unapproriate usage of mock.

You ran mock correctly. ;) The package doesn't build because of the two missing BRs python-devel and zeromq-devel.



> [ OK ] MUST: All build dependencies must be listed in BuildRequires, except for
> any that are listed in the exceptions section of the Packaging Guidelines ;
> inclusion of those as BuildRequires is optional. Apply common sense.

Not OK since BRs are missing, see above.


> [ OK ] MUST: A package must own all directories that it creates. If it does not
> create a directory that it uses, then it should require a package which does
> create that directory.

Not OK: %{_datadir}/%{name}/ is unowned. Denis, add "%dir %{_datadir}/%{name}/" to the devel package to fix it.


> [ BAD ] MUST: Packages must NOT contain any .la libtool archives, these must be
> removed in the spec if they are built. ===> I am not sure about that, are there
> any .la archives created? If not, consider it as OK.

There are no .la files created, so this is OK.


> [ BAD ] SHOULD: If the source package does not include license text(s) as a
> separate file from upstream, the packager SHOULD query upstream to include it.
> ===> No license file included.

File COPYING is present in the base and doc package (see corresponding %files section) ==> this is OK.


> [ BAD ] SHOULD: Usually, subpackages other than devel should require the base
> package using a fully versioned dependency. ===> doc package doesn't require
> the base package.

That's OK. Plain doc packages don't have to require the base package as there are useful without it. 

=============================


$ rpmlint *.rpm
5 packages and 0 specfiles checked; 0 errors, 0 warnings.

---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license.
    - LGPLv2+ according to manpages

[+] MUST: The License field in the package spec file must match the actual license.
[+] MUST: The file containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source.
[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, ...
[X] MUST: All build dependencies must be listed in BuildRequires.
    - missing BRs: python-devel, zeromq-devel

[+] MUST: When compiling C, C++, or Fortran files, %{optflags} must be applied.
[.] MUST: The spec file MUST handle locales properly.
[+] MUST: Packages storing shared library files (not just symlinks) must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, ...
[X] MUST: A package must own all directories that it creates. 
    - %{_datadir}/%{name}/ is unowned

[+] MUST: A Fedora package must not list a file more than once in %files.
[+] MUST: Permissions on files must be set properly.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[+] MUST: Large documentation files must go in a -doc subpackage.
[+] MUST: Files in %doc must not affect the runtime of the application.
[+] MUST: Header files must be in a -devel package.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: If a package contains .so files with a suffix, then .so files without suffix must go in a -devel package.
[+] MUST: devel packages must require the base package using a fully versioned dependency.
[+] MUST: Packages must NOT contain any .la libtool archives.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: All filenames in rpm packages must be valid UTF-8.

EPEL <= 5 only:
[+] MUST: The spec file must contain a valid BuildRoot field.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot}.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot}.
[+] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[X] SHOULD: The reviewer should test that the package builds in mock.
[+] SHOULD: The reviewer should test that the package functions as described.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[+] SHOULD: pkgconfig(.pc) files should be placed in a -devel pkg.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[+] SHOULD: Your package should contain man pages for binaries/scripts.
Comment 4 Denis Arnaud 2011-08-19 12:20:06 EDT
Many thanks for that review!
(and sorry for the missing BRs)

The new files are as following:
-------------------------------
Spec URL: http://denisarnaud.fedorapeople.org/sim/airrac/airrac-0.1.0-2.spec
SRPM URL:
http://denisarnaud.fedorapeople.org/sim/airrac/airrac-0.1.0-2.fc15.src.rpm
-----------------------------------------------------------------------------
Comment 5 Martin Gieseking 2011-08-19 13:31:00 EDT
(In reply to comment #4)
> Many thanks for that review!

You're welcome. 

The package looks good now. However, while it builds successfully for F15, it fails for F16: http://koji.fedoraproject.org/koji/taskinfo?taskID=3286699
The problem seems to be related to a newer version of the Boost libraries. You probably have to rebuild stdair.

----------------
Package APPROVED
----------------
Comment 6 Denis Arnaud 2011-08-19 13:48:31 EDT
(In reply to comment #5)
> The problem seems to be related to a newer version of the Boost libraries. You
> probably have to rebuild stdair.

Absolutely. Due to the freeze for F16 Alpha, package rebuilds did not find their way to the updates repository: they are still waiting on updates-testing: https://admin.fedoraproject.org/updates/stdair-0.36.2-2.fc16 .
Comment 7 Jon Ciesla 2011-08-19 14:22:46 EDT
Please include a SCM request when setting the accompannying flag.  Thanks!
Comment 8 Denis Arnaud 2011-08-19 16:21:02 EDT
New Package SCM Request
=======================
Package Name: airrac
Short Description: C++ Simulated Revenue Accounting (RAC) System Library
Owners: denisarnaud
Branches: f14 f15 f16 el4 el5 el6
InitialCC: denisarnaud
Comment 9 Jon Ciesla 2011-08-19 22:08:36 EDT
Martin, please set review flag to +.
Comment 10 Martin Gieseking 2011-08-20 01:35:24 EDT
OK, someone played around with the ticket properties. ;) Setting component back to "Package Review" and the review flag to +.
Denis, please set the fedora-cvs flag again.
Comment 11 Denis Arnaud 2011-08-20 04:53:05 EDT
New Package SCM Request
=======================
Package Name: airrac
Short Description: C++ Simulated Revenue Accounting (RAC) System Library
Owners: denisarnaud
Branches: f14 f15 f16 el4 el5 el6
InitialCC: denisarnaud
Comment 12 Jon Ciesla 2011-08-20 11:13:08 EDT
Git done (by process-git-requests).

Once more, with feeling.  And a one, and a two. . .
Comment 13 Fedora Update System 2011-08-20 20:30:48 EDT
airrac-0.1.0-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/airrac-0.1.0-2.fc16
Comment 14 Fedora Update System 2011-08-20 20:35:10 EDT
airrac-0.1.0-2.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/airrac-0.1.0-2.fc14
Comment 15 Fedora Update System 2011-08-20 22:12:10 EDT
airrac-0.1.1-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/airrac-0.1.1-1.fc15
Comment 16 Fedora Update System 2011-08-22 14:35:27 EDT
airrac-0.1.0-2.fc16 has been pushed to the Fedora 16 testing repository.
Comment 17 Fedora Update System 2011-08-30 16:38:06 EDT
airrac-0.1.0-2.fc16 has been pushed to the Fedora 16 stable repository.
Comment 18 Fedora Update System 2011-08-30 21:33:53 EDT
airrac-0.1.1-1.fc15 has been pushed to the Fedora 15 stable repository.
Comment 19 Fedora Update System 2011-08-30 21:37:54 EDT
airrac-0.1.0-2.fc14 has been pushed to the Fedora 14 stable repository.

Note You need to log in before you can comment on or make changes to this bug.